(*
     ࠡ⪨ ᪫⥫ 権  TurboPascal.
    -------------------------------------------------------------

  믮 ⮩ ᨭ⠪᪨  ࠧ  ࠦ    ᫥
१. ⨬ ⥫ ᫠, ᪮,  樨  ᫮
 㬭. ᯮ ࠧ ⮤ ४ᨢ  ᪠.  訡
        ஢  ४ᨨ.    ⮬  ࠢ
頥   ணࠬ    ।⢥    맮
㭪樨 "SetExceptionHandler"  ⠭  ⢥ १  
樨 (  砥 _ERR).

    맮 "SetExceptionHandler",  ⮬  ⥪騬
  ᫥,      ⠫         ⥪.   
⨢樨  ⥪饣  ࠡ稪  (  ⨢樨  ।饣  
⥪)     ᯮ     "ResetExceptionHandler".        㦤
᪫⥫쭮 樨 - 楤 "RaiseException". ࠬ  -  
樨.

  He ४:
   - ⬥ ࠡ稪,    ⠭
   -  ⬥ ࠡ稪  室  楤,   
     ⠭

   ᫥騩 ⨫ (  ADA):

{   砫  }
  Exc := SetExceptionHandler;
  case Exc of
    0: ;
    ...  {  ࠡ稪 ᢮ ᪫祭 }
    else begin
       ... { ⥫ ⢨   訡 }
      ResetExceptionHandler;
      RaiseException(Exc);  {  -   ᮪ ஢ }
    end;
{-----------}

{    । 室  楤 }
  ResetExceptionHandler;
{-----------}


*)

program TestExc;
uses Crt, ExcUnit;

const _ERR = 1;


var TOKEN:string;
    Ch:char;

function E:integer;forward;
function F:integer;forward;
function P:integer;forward;

procedure ERROR(MSG:string);
begin
  WriteLn;
  WriteLn(MSG);
  {halt;}
  RaiseException(_ERR);   {  뢠 ணࠬ,  ࠡ 訡 }
end;

procedure GetChar;
begin
  Ch := ReadKey; Write(Ch);
end;

procedure GetTOKEN;
begin
  TOKEN := '';
  while Ch = ' ' do GetChar;
  if Ch in ['*', '+', '(', ')', '='] then begin
    TOKEN := Ch; Ch := ' '; exit
  end;
  while Ch in ['0'..'9'] do begin
    TOKEN := TOKEN + Ch; GetChar
  end;
  if TOKEN = '' then ERROR('LexicalERR:  ࠧ⥫');
end;

function P:integer;         (*  4.  P ::= '(' E ')' | ᫮  *)
var Num,K:integer;
begin
  if TOKEN = '(' then begin
    GetTOKEN;
    P := E;
    if TOKEN <> ')' then ERROR('SyntaxERR:  ࠢ ᪮');
    GetTOKEN;
    exit
  end;
  Val(TOKEN,Num,K);
  if K <> 0 then ERROR('SyntaxERR: 訡  ᫥');
  P := Num;
  GetTOKEN;
end;


function F:integer;         (*  3.  F ::= P {'*' P}  *)
var Mult:integer;
begin
  Mult := P;
  while TOKEN = '*' do begin
    GetTOKEN; Mult := Mult * P
  end;
  F := Mult;
end;


function E:integer;         (*  2.  E ::= F {'+' F}  *)
var Sum:integer;
begin
  Sum := F;
  while TOKEN = '+' do begin
    GetTOKEN; Sum := Sum + F
  end;
  E := Sum;
end;


var Exc:word;
    S:integer;              (*  1.  S ::= E '='  *)
begin
  Exc := SetExceptionHandler;
  case Exc of
    0 : ;

    _ERR :
      begin
        WriteLn('Exception !!!');
        WriteLn(' ⥫, ⠩  ࠧ');
      end;

    else begin
      halt;
    end;

  end {case};

  Ch := ' ';
  GetTOKEN;
  S := E;
  if TOKEN <> '=' then ERROR('SyntaxERR:   ࠢ⢠');
  WriteLn(S);

  ResetExceptionHandler;
end.


